// 001 u_05_05_class_constraint
// 25 nov 2010

(*$r+*)

unit u_c_class_constraint;
  interface

    type c_data_container <T: class> =
             class
               private
                 m_c_data: T;
               public
                 constructor create_data_container(p_c_data: T);

                 procedure display_data;
                 function ToString: String; Override;

                 Destructor Destroy; Override;
               end; // c_data_container

  implementation
    uses SysUtils, u_display_simple;

    { c_data_container<T> }

    constructor c_data_container<T>.create_data_container(p_c_data: T);
      begin
        m_c_data:= p_c_data;
      end; // create_data_container

    procedure c_data_container<T>.display_data;
      begin
        if Assigned (m_c_data) then
        begin
          display('ClassName: ' + m_c_data.ClassName);
          display('Size:      ' + IntToStr (m_c_data.InstanceSize));
          display('ToString:  ' + m_c_data.ToString);
        end;
      end; // display_data

    function c_data_container<T>.ToString: String;
      begin
        // -- can use ToString since m_c_data is in tObject
        Result:= 'c_data_container<T>.ToString '+ m_c_data.ToString;
      end; // ToString

    Destructor c_data_container<T>.Destroy;
      begin
        m_c_data.Free;
        Inherited;
      end; // Destroy

end.
